import edu.rice.cs.mint.runtime.*;

public class EscapeStat {
    public static separable Code<Integer> foo() { return <| 1 |>; }
    public static separable Code<Void> bar() { return <| { System.out.println("bar"); } |>; }
    public static separable Code<?> xyz() { return <| { System.out.println("xyz"); } |>; }
    public static separable Code<?> abc() { return <| 5 |>; }
    
    public static void main(String [] args) {
        <| { int i = `(foo()); `(bar()); `(foo()); `(foo()); } |>.run(); // WARNING
 // error if xyz() or abc() is escaped in
        // <| { int i = `(foo()); `(bar()); `(foo()); `(foo()); `(xyz()); `(abc()); } |>.run();
    }
}
